<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		flagrant
 */

class Hook_checklist_flagrant
{

	/**
	 * Standard modular run function.
	 *
	 * @return array		An array of tuples: The task row to show, the number of seconds until it is due (or NULL if not on a timer), the number of things to sort out (or NULL if not on a queue), The name of the config option that controls the schedule (or NULL if no option).
	 */
	function run()
	{
		if (!addon_installed('flagrant')) return array();

		require_lang('flagrant');

		$num_queue=$this->get_num_flagrant_queue();

		$rows=$GLOBALS['SITE_DB']->query_select('text',array('activation_time','days'),array('active_now'=>1),'',NULL,NULL,true);
		if (is_null($rows)) return array();
		$seconds_due_in=mixed();
		if (array_key_exists(0,$rows))
		{
			$activation_time=$rows[0]['activation_time'];
			$days=$rows[0]['days'];

			$date=$activation_time+$days*24*60*60;

			$seconds_due_in=$date-time();
			$status=($seconds_due_in<=0)?0:1;
		} else
		{
			$status=($num_queue==0)?1:0; // If none set, but one waiting, task is not done

			if ($num_queue!=0) $seconds_due_in=0;
		}

		$_status=($status==0)?do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_0'):do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM_STATUS_1');

		$url=build_url(array('page'=>'admin_flagrant','type'=>'misc'),'adminzone');
		list($info,$seconds_due_in)=staff_checklist_time_ago_and_due($seconds_due_in);
		$info->attach(do_lang_tempcode('NUM_QUEUE',escape_html(integer_format($num_queue))));
		$tpl=do_template('BLOCK_MAIN_STAFF_CHECKLIST_ITEM',array('_GUID'=>'820e0e3cd80754dc7dfd9a0d05a43ec0','URL'=>$url,'STATUS'=>$_status,'TASK'=>do_lang_tempcode('CHOOSE_FLAGRANT'),'INFO'=>$info));
		return array(array($tpl,$seconds_due_in,NULL,NULL));
	}

	/**
	 * Get the number of flagrant text messages in the queue.
	 *
	 * @return integer		Number in queue
	 */
	function get_num_flagrant_queue()
	{
		$c=$GLOBALS['SITE_DB']->query_value_null_ok_full('SELECT COUNT(*) FROM '.get_table_prefix().'text WHERE activation_time IS NULL');
		if (is_null($c)) return 0;
		return $c;
	}

}


